_         = require 'lodash'
debug     = require('debug')('meshblu-authenticator-cwc:device-controller')
jwt       = require 'jsonwebtoken'
url       = require 'url'

class DeviceController
  constructor: ({@deviceAuthService}) ->

  decodeToken: (token) =>
    jwt.decode token

  prepare: (request, response, next) =>
    {token} = request.body
    return response.status(422).send 'Token Required' if _.isEmpty(token)

    profile = @decodeToken token
    return response.status(422).send 'Invalid Token' unless profile?

    request.profile = profile
    next()

  create: (request, response) =>
    debug 'create'
    {body, profile} = request
    {callbackUrl} = body
    fake_secret = "cwc-authenticator-staging"

    @deviceAuthService.findAuthorizedCWCUserDevice profile, fake_secret, (error, device) =>
      debug 'findAuthorizedCWCUserDevice', error, device?
      return response.sendError error if error?
      return response.status(201).send device: device, callbackUrl: @getCallbackUrlWithMeshbluAuth(device, callbackUrl)

  getCallbackUrlWithMeshbluAuth: (device, callbackUrl) =>
    return unless callbackUrl?
    uriParams = url.parse callbackUrl, true
    delete uriParams.search
    uriParams.query ?= {}
    uriParams.query.uuid  = device.uuid
    uriParams.query.token = device.token
    return decodeURIComponent url.format(uriParams)


module.exports = DeviceController
