cors               = require 'cors'
morgan             = require 'morgan'
octobluExpress     = require 'express-octoblu'
sendError          = require 'express-send-error'
packageVersion     = require 'express-package-version'
bodyParser         = require 'body-parser'
meshbluHealthcheck = require 'express-meshblu-healthcheck'
MeshbluConfig      = require 'meshblu-config'
OctobluRaven       = require 'octoblu-raven'
Router             = require './router'

class Server
  constructor: ({@disableLogging, @port, @octobluRaven}, {@meshbluConfig})->
    @meshbluConfig ?= new MeshbluConfig().toJSON()
    @octobluRaven ?= new OctobluRaven()

  address: =>
    @server.address()

  run: (callback) =>
    app = octobluExpress({ @disableLogging, bodyLimit: '10mb' })

    router = new Router {@meshbluConfig}
    router.route app
    @server = app.listen @port, callback

  stop: (callback) =>
    @server.close callback

module.exports = Server
